#pragma once
#include <iomanip>
#include <sstream>
#include <string>

#include "ONSClient.h"

ROCKETMQ_NAMESPACE_BEGIN

class ONSCLIENT_API MessageQueueONS {
   public:
    MessageQueueONS();
    MessageQueueONS(const std::string& topic, const std::string& brokerName, int queueId);

    MessageQueueONS(const MessageQueueONS& other);
    MessageQueueONS& operator=(const MessageQueueONS& other);

    std::string getTopic() const;
    void setTopic(const std::string& topic);

    std::string getBrokerName() const;
    void setBrokerName(const std::string& brokerName);

    int getQueueId() const;
    void setQueueId(int queueId);

    bool operator==(const MessageQueueONS& mq) const;
    bool operator<(const MessageQueueONS& mq) const;
    int compareTo(const MessageQueueONS& mq) const;

   private:
    std::string m_topic;
    std::string m_brokerName;
    int m_queueId;
};

ROCKETMQ_NAMESPACE_END