#pragma once

// Static library use case
#ifdef ONSCLIENT_STATIC_LIBRARY

#define ONSCLIENT_API

// Dynamic shared library, also known as DLL use case
#else

// Windows platform
#ifdef _WIN32

// Scenario without Swig
#ifndef SWIG

// Symbols to export in DLL use cases
#ifdef ONSCLIENT_EXPORTS
#define ONSCLIENT_API __declspec(dllexport)
#else
#define ONSCLIENT_API __declspec(dllimport)
#endif

// Scenario with Swig
#else
// Refer http://www.swig.org/Doc1.3/Windows.html
// SWIG parses ISO C/C++ so cannot deal with proprietary conventions such as __declspec(dllimport), __stdcall etc.
#define ONSCLIENT_API
#endif

// Non Windows platform macro definition
#else

// Symbols should export in dynamic shared library use cases
#ifdef ONSCLIENT_EXPORTS
#define ONSCLIENT_API __attribute__((visibility("default")))
#else
#define ONSCLIENT_API
#endif

#endif

// End of dynamic shared library, also known as, DLL use case
#endif

#ifndef ROCKETMQ_NAMESPACE
#define ROCKETMQ_NAMESPACE ons
#endif


#define ROCKETMQ_NAMESPACE_BEGIN namespace ROCKETMQ_NAMESPACE {
#define ROCKETMQ_NAMESPACE_END   }

#define UNUSED(x) (void)(x)

ROCKETMQ_NAMESPACE_BEGIN

enum LanguageIdentifier : int32_t {
    JAVA = 0,
    CPP = 1,
    DOT_NET = 2,
    PYTHON = 3,
    DELPHI = 4,
    ERLANG = 5,
    RUBY = 6,
    OTHER = 7,
    HTTP = 8,
    GO = 9,
    PHP = 10,
    OMS = 11
};

ROCKETMQ_NAMESPACE_END