#pragma once

#include "Message.h"
#include "SendResultONS.h"
#include "ONSClient.h"

ROCKETMQ_NAMESPACE_BEGIN

class ONSCLIENT_API OrderProducer {
 public:
  OrderProducer() = default;

  virtual ~OrderProducer() = default;

  // before send msg, start must be called to allocate resources.
  virtual void start() = 0;
  // before exit ons, shutdown must be called to release all resources allocated
  // by ons internally.
  virtual void shutdown() = 0;

  /**
   * @param msg Message to send.
   * @param shardingKey
   * @return
   */
  virtual SendResultONS send(Message& msg, std::string message_group) noexcept(false) = 0;

  virtual SendResultONS send(Message &msg, std::string message_group, std::error_code& ec) = 0;
};

ROCKETMQ_NAMESPACE_END