#pragma once

#include <vector>

#include "Message.h"

ROCKETMQ_NAMESPACE_BEGIN

enum ONSPullStatus {
    ONS_FOUND,
    ONS_NO_NEW_MSG,
    ONS_NO_MATCHED_MSG,
    ONS_OFFSET_ILLEGAL,
    ONS_BROKER_TIMEOUT  // indicate pull request timeout or received NULL response
};

class ONSCLIENT_API PullResultONS {
   public:
    explicit PullResultONS(ONSPullStatus status) : pullStatus(status), nextBeginOffset(0), minOffset(0), maxOffset(0) {}

    PullResultONS(ONSPullStatus pullStatus, long long nextBeginOffset, long long minOffset, long long maxOffset)
        : pullStatus(pullStatus), nextBeginOffset(nextBeginOffset), minOffset(minOffset), maxOffset(maxOffset) {}

    virtual ~PullResultONS() = default;

   public:
    ONSPullStatus pullStatus;
    long long nextBeginOffset;
    long long minOffset;
    long long maxOffset;
    std::vector<Message> msgFoundList;
};

ROCKETMQ_NAMESPACE_END