#pragma once

#include "LocalTransactionExecuter.h"
#include "ONSClient.h"
#include "SendResultONS.h"

ROCKETMQ_NAMESPACE_BEGIN

class ONSCLIENT_API TransactionProducer {
   public:
    TransactionProducer() {}

    virtual ~TransactionProducer() {}

    // before send msg, start must be called to allocate resources.
    virtual void start() = 0;

    // before exit ons, shutdown must be called to release all resources allocated
    // by ons internally.
    virtual void shutdown() = 0;

    /**
     * Send a message which associates itself with local transaction.
     *
     * @param msg The message to send.
     * @param executor Pointer to a callable that executes local transaction.
     * @return
     */
    virtual SendResultONS send(Message &msg, LocalTransactionExecuter *executor) noexcept(false) = 0;

    virtual SendResultONS send(Message &msg, LocalTransactionExecuter *executor, std::error_code& ec) = 0;
};

ROCKETMQ_NAMESPACE_END